* Program-ID.....: DATAFIX.PRG
* Author.........: Pinter Consulting Staff.
* Purpose........: Restructures data base files using data dictionary.
* Comments.......: Uses the data dictionary file from the July Newsletter.

SET TALK OFF 
SET SAFETY OFF 
SET ESCAPE OFF 

ON ERROR DO errtrap WITH PROGRAM(),LINENO(),ERROR(),MESSAGE(),MESSAGE(1)

prefix    = []   && Add a directory prompt dialogue here if you want.

screencol = IIF( ISCOLOR() , "GR+/B,B/BG",  "W+/N,N/W"  )
blinkcol  = IIF( ISCOLOR() , "GR*+/B,B/BG", "W*+/N,N/W" )

SET COLOR TO &ScreenCol
SET STATUS ON 
CLEAR 
SET SCOREBOARD OFF 
SET MESSAGE TO 24

@ 0, 0, 24, 79 BOX "ͻȺ"
SET COLOR TO &BlinkCol
@ 12, 25 SAY 'One moment - loading field names'
SET COLOR TO &ScreenCol

USE DATADICT EXCLUSIVE 
*- Create this file by hand, or use DATADICT.PRG from July NewsLetter.
*  Structure for database: DATADICT.DBF
*  Field  Field Name  Type       Width    Dec
*      1  FILE        Character     12
*      2  DESCRIPT    Character     40           ** Optional field.
*      3  FIELD_NAME  Character     10
*      4  FIELD_TYPE  Character      1
*      5  FIELD_LEN   Numeric        3
*      6  FIELD_DEC   Numeric        3
*  ** Total **                      70

COPY STRUCTURE EXTENDED TO buildfil

max       = 256                      && use whatever you want here.
tot       = RECCOUNT()

DIMENSION fyle       (max),nfields    (max),starts    (max)
DIMENSION field_name (tot),field_type (tot),field_len (tot)
DIMENSION field_dec  (tot)

STORE ' ' TO fyle
STORE 0  TO nfields, starts

lastfile  = ' '
filecount = 0

DO WHILE .NOT. EOF()
   
   IF FILE <> lastfile
      lastfile  = FILE 
      filecount = filecount + 1
      starts    ( filecount ) = RECNO()
      fyle      ( filecount ) = FILE 
      ncount    = 0
   ENDIF 
   
   field_name ( RECNO() ) = field_name
   field_type ( RECNO() ) = field_type
   field_len  ( RECNO() ) = field_len
   field_dec  ( RECNO() ) = field_dec
   
   nfields ( filecount ) = nfields ( filecount ) + 1
   
   SKIP 
   
ENDDO 
CLOSE DATABASES 

SET STATUS OFF 

DO WHILE .T.
   
   @ 0, 0, 22, 79 BOX "ͻȺ"
   @ 11, 28 CLEAR TO 13,52
   @ 11, 28       TO 13,52 DOUBLE 
   a = center ( 12, 'File Repair' )
   @ 23, 0 CLEAR 
   
   @ 23,       0 PROMPT  " All "  ;
                 MESSAGE " Test files for integrity"
   @ 23, COL()+1 PROMPT  " One "  ;
                 MESSAGE " Test a selected file for integrity"
   @ 23, COL()+1 PROMPT  " Quit " ;
                 MESSAGE " Exit this program."
   
   which = 1
   
   SET CONFIRM OFF 
   MENU TO which
   @ 23, 0 CLEAR 
   
   DO CASE 
      
   CASE which = 0 .OR. which = 3
      
      EXIT 
      
   CASE which = 1
      
      FOR whichfile = 1 TO filecount
         DO FixOne
      ENDFOR
      KEYBOARD "Q"
      
   CASE which = 2
      
      @ 2, 3 MENU fyle , filecount, 17 TITLE "Pick a file" SHADOW
      whichfile = 1
      SET  CONFIRM ON
      READ MENU TO whichfile
      SET  CONFIRM OFF
      IF whichfile = 0
         LOOP 
      ENDIF 
      DO FixOne
      
   ENDCASE 
   
ENDDO 

CLOSE DATABASES 

IF FILE ( 'BUILDFIL.DBF' )
   DELETE FILE BUILDFIL.DBF
ENDIF

IF FILE ( 'FILEDEF.DBF' )
   DELETE FILE FILEDEF.DBF
ENDIF

IF LEN(TRIM(SYS(16,2))) = 0
   QUIT 
ELSE 
   RETURN 
ENDIF 



PROCEDURE FixOne

fil = prefix + fyle ( whichfile )

IF FILE( fil )
   
   USE &fil EXCLUSIVE 
   
   COPY STRUCTURE EXTENDED TO filedef
   startrec = starts ( whichfile )
   
   RELEASE filedef
   DIMENSION filedef(FCOUNT(),4)
   
   USE FILEDEF EXCLUSIVE 
   SCAN
      filedef(RECNO(),1) = field_name
      filedef(RECNO(),2) = field_type
      filedef(RECNO(),3) = field_len
      filedef(RECNO(),4) = field_dec
   ENDSCAN
   
   USE &fil EXCLUSIVE 
   
   differences = .F.
   
   FOR i = 1 TO FCOUNT()
      IF       filedef(i,1) <> field_name(startrec + i - 1 ) ;
         .OR.  filedef(i,2) <> field_type(startrec + i - 1 ) ;
         .OR.  filedef(i,3) <> field_len (startrec + i - 1 ) ;
         .OR.  filedef(i,4) <> field_dec (startrec + i - 1 )
         differences = .T.
         EXIT
      ENDIF
   ENDFOR
   
ENDIF

DO CASE 
   
   CASE .NOT. FILE( fil )

      DO DrawBox

      @ 15, 24 SAY 'File does not exist.'
      @ 16, 24 SAY 'Creating ' + fil

      DO FixFile WITH whichfile

      DO EraseBox

   CASE FCOUNT() <> nfields ( whichfile )

      DO DrawBox

      should = STR( nfields ( whichfile ) , 2 )
      does   = STR( FCOUNT()            , 2 )
      @ 15, 24 SAY 'File should have ' + should ;
                 + ' fields - has ' + does + '.'
      @ 16, 24 SAY 'Fixing ' + fyle ( whichfile)

      DO FixFile WITH whichfile

      DO EraseBox

   CASE differences

      DO DrawBox

      @ 15, 24 SAY 'The file has been changed.'
      @ 16, 24 SAY 'Fixing ' + fyle ( whichfile)

      DO FixFile WITH whichfile

      DO EraseBox

   OTHERWISE

      @ 24, 0 CLEAR
      @ 24, 0 SAY "No errors found for file " + fil
      WAIT WINDOW TIMEOUT 1

ENDCASE

RETURN 


PROCEDURE FixFile
PARAMETERS filenum

@ 24, 0 CLEAR 
@ 24, 0 SAY 'Fixing file ' + fyle ( filenum )

fil = fyle ( filenum )

sav = fil
sav = LEFT( sav , AT( [.DBF] , sav ) - 1 ) + [.BAK]

IF FILE ( sav )
   IF .NOT. yn( 14 , [ Backup file already exists - delete it? ] )
      WAIT "Returning to menu - rebuild of file cancelled" ;
       WINDOW TIMEOUT 1
      RETURN 
   ELSE 
      DELETE FILE &sav
   ENDIF 
ENDIF 

CLOSE DATABASES 

USE BUILDFIL EXCLUSIVE 
ZAP 

i  = starts  ( filenum )
j  = 1
DO WHILE j <= nfields ( filenum )
   APPEND BLANK 
   REPLACE NEXT 1 field_name WITH field_name ( i )
   REPLACE NEXT 1 field_type WITH field_type ( i )
   REPLACE NEXT 1 field_len  WITH field_len  ( i )
   REPLACE NEXT 1 field_dec  WITH field_dec  ( i )
   i = i + 1
   j = j + 1
ENDDO 

CLOSE DATABASES 

datafile = prefix + "DATAFILE.DBF"

CREATE &DATAFILE FROM buildfil
USE &DATAFILE EXCLUSIVE 

errflag = .F.
IF FILE( fil )
   APPEND FROM &fil
ENDIF 

USE 

IF .NOT. errflag
   IF FILE( fil )
      RENAME &fil      TO &sav
   ENDIF 
   RENAME &DATAFILE TO &fil
ENDIF 

USE 

RETURN 



PROCEDURE center
PARAMETERS line_num,MESSAGE 
length = 80
length = length / 2
@ line_num,length-LEN(MESSAGE )/2 SAY MESSAGE 
RETURN .t.



PROCEDURE YN
PARAMETERS row, msg

rownum = IIF( row > 19, 19, row )

DEFINE   WINDOW x FROM rownum, 2 TO rownum+3, 77 SHADOW DOUBLE
ACTIVATE WINDOW x
CLEAR 
a = center ( 0 , msg )
@ 1, 35 PROMPT " Yes "
@ 1, 41 PROMPT " No "
z = 1
MENU TO z

RELEASE WINDOW x

RETURN IIF( z = 1 , .T. , .F. )



PROCEDURE DrawBox

SAVE SCREEN 

?? CHR(7)
SET COLOR TO n/n
@ 15, 21, 18, 61 BOX "ͻȺ "
SET COLOR TO &ScreenCol
@ 14, 20, 17, 60 BOX "ͻȺ "

RETURN 


PROCEDURE EraseBox

RESTORE SCREEN 

RETURN 
